# 決済手段 更新

`PUT /v1/customers/{customer_id}/payment_methods/{id}`

- operationId: `updateCustomerPaymentMethod`
- tags: 決済手段

`customer_id`で指定した顧客に対し紐づく決済手段のうち、`id`で指定したものを更新します。


## コードサンプル

### cURL

```bash
curl \
    -X PUT \
    -H "Authorization:Bearer <Secret API Key>" \
    -H "Content-Type:application/json" \
    -d '{"pay_type": "Card", "default_flag": "1"}' \
'https://api.test.fincode.jp/v1/customers/{customer_id}/payment_methods/{id}'
```

### Node.js

```javascript
import fetch from "node-fetch";

const BASE_URL = "https://api.test.fincode.jp";

const API_KEY = "<Secret API Key>";

(async () => {
    const customerId = "<Customer ID>";
    const paymentMethodId = "<Payment Method ID>";

    const endpoint = `${BASE_URL}/v1/customers/${customerId}/payment_methods/${paymentMethodId}`;

    const body = {
        pay_type: "Card",
        default_flag: "1",
    };

    const response = await fetch(endpoint, {
        method: "PUT",
        headers: {
            Authorization: `Bearer ${API_KEY}`,
            "Content-Type": "application/json",
        },
        body: JSON.stringify(body),
    });
    const result = await response.json();
})();
```

### Go

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"log"
	"net/http"
)

func main() {

	apiKey := "<Secret API Key>"

	customerID := "<Customer ID>"
	paymentMethodID := "<Payment Method ID>"

	body := UpdatingPaymentMethodRequest{
		PayType:     "Card",
		DefaultFlag: "1",
	}

	marshalledBody, _ := json.Marshal(body)

	url := fmt.Sprintf("https://api.test.fincode.jp/v1/customers/%s/payment_methods/%s", customerID, paymentMethodID)

	// リクエストの作成
	req, _ := http.NewRequest(
		"PUT",
		url,
		bytes.NewBuffer(marshalledBody),
	)
	req.Header.Set("Authorization", fmt.Sprintf("Bearer %s", apiKey))
	req.Header.Set("Content-Type", "application/json")

	// リクエストの送信
	client := &http.Client{}
	res, err := client.Do(req)
	if err != nil {
		log.Fatal(err)
	}
	defer res.Body.Close()
}

type UpdatingPaymentMethodRequest struct {
	PayType     string `json:"pay_type"`
	DefaultFlag string `json:"default_flag"`
}
```

### PHP

```php
<?php

$apiKey = '<Secret API Key>';

$customerId = '<Customer ID>';
$paymentMethodId = '<Payment Method ID>';

$baseUrl = "https://api.test.fincode.jp";
$endpoint = "/v1/customers/{$customerId}/payment_methods/{$paymentMethodId}";
$body = [
    "pay_type" => "Card",
    "default_flag" => "1",
];

$headers = [
    "Authorization: Bearer " . $apiKey,
    "Content-Type: application/json",
];

$session = curl_init();
curl_setopt($session, CURLOPT_URL, $baseUrl . $endpoint);
curl_setopt($session, CURLOPT_HTTPHEADER, $headers);
curl_setopt($session, CURLOPT_CUSTOMREQUEST, 'PUT');
curl_setopt($session, CURLOPT_POSTFIELDS, json_encode($body));
curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
// curl_setopt($session, CURLOPT_SSL_VERIFYPEER, );
// curl_setopt($session, CURLOPT_SSL_VERIFYHOST, );

$response = curl_exec($session);

if ($response === false) {
    # エラー処理
    echo "cURL Error: " . curl_error($session);
} else {
    # APIからのデータを処理
    var_dump($response);
}

curl_close($session);
```

### Python 3

```python
import requests

api_key = '<Secret API Key>'

customer_id = '<Customer ID>'
payment_method_id = '<Payment Method ID>'

url = f'https://api.test.fincode.jp/v1/customers/{customer_id}/payment_methods/{payment_method_id}/'
body = {
    'pay_type': 'Card',
    'default_flag': '1',
}

# ヘッダーを設定
headers = {
    'Authorization': f'Bearer {api_key}',
    'Content-Type': 'application/json',
}

try:
    response = requests.put(url, headers=headers, json=body)

    # レスポンスの処理
    if response.status_code == 200:
        # APIからのデータを処理
        print(f"Success: {response.json()}")
    else:
        # エラーの処理
        print(f"Error: {response.json()}")
except requests.RequestException as e:
    # 通信エラーの処理
    print(f"Request error: {e}")
```

### Ruby

```ruby
require 'net/http'
require 'uri'
require 'json'

API_KEY = '<Secret API Key>'
BASE_URL = 'https://api.test.fincode.jp'

def main
    customer_id = '<Customer ID>'
    payment_method_id = '<Payment Method ID>'

    endpoint = "/v1/customers/#{customer_id}/payment_methods/#{payment_method_id}"
    body = {
        pay_type: 'Card',
        default_flag: '1',
    }

    uri = URI.parse(BASE_URL + endpoint)

    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true

    # リクエストの作成
    request = Net::HTTP::Put.new(uri.request_uri)
    request['Authorization'] = "Bearer #{API_KEY}"
    request['Content-Type'] = 'application/json'
    request.body = body.to_json

    # リクエストの送信
    response = http.request(request)

    case response
    when Net::HTTPSuccess
        puts 'SUCCESS'
    else
        puts 'ERROR'
    end

    # レスポンスの表示
    puts response.body
end

main
```

## パラメータ

| 名前 | 位置 | 必須 | 型 | 説明 |
| --- | --- | --- | --- | --- |
| `customer_id` | path | ✓ | CustomerId_schema | 顧客ID |
| `id` | path | ✓ | PaymentMethodId_schema | 決済手段ID |
| `Tenant-Shop-Id` | header |  | schema | <span class="smallText color--red-400">※ 顧客情報を共有しないプラットフォームのメインショップのみ指定可</span> |

## リクエストボディ

Content-Type: `application/json`

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `pay_type` | string | ✓ | 決済種別 |
| `default_flag` | enum(1) |  | デフォルトフラグ |
| `return_url` | return_url |  | <span class="smallText">※ `pay_type = "Card"`のとき指定可能</span> |
| `return_url_on_failure` | return_url_on_failure |  | <span class="smallText">※ `pay_type = "Card"`のとき指定可能</span> |
| `client_field_1` | client_field_1 |  | 加盟店自由項目 1 |
| `client_field_2` | client_field_2 |  | 加盟店自由項目 2 |
| `client_field_3` | client_field_3 |  | 加盟店自由項目 3 |
| `card` | object |  | <span class="smallText">※ `pay_type = "Card"`のとき指定可能。カード情報自体（カード番号）は変更できません。省略した場合は`default_flag`/`client_field_*`のみが更新されます。</span> |

## レスポンス

### 200 リクエストに成功

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `id` | PaymentMethod_properties-id |  | 更新された決済手段のIDです。 |
| `pay_type` | enum(Card | Virtualaccount) |  | - `Card` |
| `customer_id` | properties-customer_id |  |  |
| `status` | status |  |  |
| `redirect_url` | redirect_url |  |  |
| `default_flag` | properties-default_flag |  |  |
| `client_field_1` | client_field_1 |  |  |
| `client_field_2` | client_field_2 |  |  |
| `client_field_3` | client_field_3 |  |  |
| `delete_flag` | properties-delete_flag |  |  |
| `process_date` | properties-process_date |  |  |
| `created` | properties-created |  |  |
| `updated` | properties-updated |  |  |
| `card` | card |  |  |
| `virtualaccount` | virtualaccount |  |  |

### 400 不正なリクエスト

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `errors` | array<FincodeAPIError> |  |  |

